Index: avi.c
===================================================================
--- avi.c	(revision 10570)
+++ avi.c	(working copy)
@@ -453,7 +453,19 @@
             /* add idx1 entry for this frame */
             p_idx = &p_sys->idx1.entry[p_sys->idx1.i_entry_count];
             memcpy( p_idx->fcc, p_stream->fcc, 4 );
-            p_idx->i_flags = AVIIF_KEYFRAME;
+            /* Check for key frame */
+            if ( p_data->i_flags & BLOCK_FLAG_NO_KEYFRAME )
+            {
+                p_idx->i_flags = AVIIF_KEYFRAME;
+            }
+            else if ( p_data->i_flags & BLOCK_FLAG_TYPE_I )
+            {
+                p_idx->i_flags = AVIIF_KEYFRAME;
+            }
+            else
+            {
+                p_idx->i_flags = 0;
+            }
             p_idx->i_pos   = p_sys->i_movi_size + 4;
             p_idx->i_length= p_data->i_buffer;
             p_sys->idx1.i_entry_count++;
@@ -792,6 +804,7 @@
     int                 i_maxbytespersec;
     int                 i_junk;
     buffer_out_t        bo;
+    buffer_out_t        _bo_sav_;
 
     p_hdr = block_New( p_mux, HDR_SIZE );
     memset( p_hdr->p_buffer, 0, HDR_SIZE );
@@ -803,6 +816,7 @@
     bo_AddFCC( &bo, "AVI " );
 
     bo_AddFCC( &bo, "LIST" );
+    _bo_sav_ = bo;
     bo_AddDWordLE( &bo, HDR_SIZE - 8);
     bo_AddFCC( &bo, "hdrl" );
 
@@ -812,6 +826,8 @@
         avi_HeaderAdd_strl( p_mux, &bo, &p_sys->stream[i_stream] );
     }
 
+    bo_AddDWordLE( &_bo_sav_, bo.i_buffer - _bo_sav_.i_buffer - 4 );
+    
     i_junk = HDR_SIZE - bo.i_buffer - 8 - 12;
     bo_AddFCC( &bo, "JUNK" );
     bo_AddDWordLE( &bo, i_junk );
